﻿--[[ 	GupPet by Gup 	]]--

-- CONSTANT
GUPPET_SCRIPTVERSION = 0.105;

-- SAVED VARS
GUPPET_MOUNTS = { SlowGroundMount = { Total=0  } , SlowFlyMount = { Total=0} , FastGroundMount = { Total=0} , FastFlyMount = { Total=0}, AquaticMount = { Total=0} , UnknownMount= { Total=0}  } ;
GUPPET_CRITTERS = { Total=0} ;


GUPPET_OPTIONS = { Debug = false , NewVersionFound  = 0 , AutoCallCritter = false , AutoCallCritterCityOnly = false } ;
GUPPET_CANFLYDALARAN = true ;



-- TEMP VARS
GUPPETTEMP_OLDREALZONETEXT = "" ;
GUPPETTEMP_OLDREALSUBZONETEXT ="";
GUPPET_CANFLY = false ;
AutoCallCritter = {} ;


-- // Work with the slash Commands // --
function GupPet_SlashCommand(msg)
	
	if ( msg =="FastGroundMount" or msg == "FGM" ) then
		_, instanceType = IsInInstance() ;
	
		if ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledCity"] > 0 and IsResting() ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledCity" , "TotalEnabledCity" ) ;
		
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledBattleGround"] > 0 and instanceType == "pvp" ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledBattleGround" , "TotalEnabledBattleGround" ) ;
			
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledArena"] > 0 and instanceType == "arena" ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledArena" , "TotalEnabledArena" ) ;
		
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledInstance"] > 0 and ( instanceType == "party" or instanceType == "raid" ) ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledInstance" , "TotalEnabledInstance" ) ;	
				
		elseif GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabled"] > 0 then
		
			GupPet_Mounten( "FastGroundMount" , "Enabled" , "TotalEnabled" ) ;
		else
				GupPet_Text( GUPPET_TEXT_CANTCALLGROUNDMOUNT ) ;
		end
		
	elseif ( msg =="FastFlyMount") or msg == "FFM" then
	
		if GUPPET_MOUNTS[ "FastFlyMount" ]["TotalEnabled"] > 0 then
			GupPet_Mounten( "FastFlyMount" , "Enabled" , "TotalEnabled" ) ;
		else
			GupPet_Text( GUPPET_TEXT_CANTCALLFLYMOUNT ) ;
		end	
	
	elseif ( msg =="SlowGroundMount" or msg == "SGM" ) then
	
		if GUPPET_MOUNTS[ "SlowGroundMount" ]["TotalEnabled"] > 0 then
			GupPet_Mounten( "SlowGroundMount" , "Enabled" , "TotalEnabled" ) ;
		else
			GupPet_Text( GUPPET_TEXT_CANTCALLGROUNDMOUNT ) ;
		end	
			
	elseif ( msg =="SlowFlyMount") or msg == "SFM" then
	
		if GUPPET_MOUNTS[ "SlowFlyMount" ]["TotalEnabled"] > 0 then
			GupPet_Mounten( "SlowFlyMount" , "Enabled" , "TotalEnabled" ) ;
		else
			GupPet_Text( GUPPET_TEXT_CANTCALLFLYMOUNT ) ;
		end	
			
	elseif ( msg =="AquaticMount")   then
	
		if GUPPET_MOUNTS[ "AquaticMount" ]["TotalEnabled"] > 0 then
			GupPet_Mounten( "AquaticMount" , "Enabled" , "TotalEnabled" ) ;
		else
			GupPet_Text( GUPPET_TEXT_CANTCALLAQUATICMOUNT ) ;
		end			
			
			
			
	elseif ( msg =="AutoMount" ) or msg == "AM"	 then
		
		GupPet_AutoMount() ;
		
	elseif ( msg =="CallCritter") or msg == "CC" then	
		
		GupPet_CallCritter() ;
	 
	elseif ( msg =="Debug"	) then
	
		if GUPPET_OPTIONS.Debug == false then
		
			GUPPET_OPTIONS.Debug = true ;
			GupPet_Text( "Debug mode ON" );
		else
			GUPPET_OPTIONS.Debug = false ;
			GupPet_Text( "Debug mode OFF" );		
		end		
		
	elseif ( msg == "test") then
	
	
		
	else		
		 DEFAULT_CHAT_FRAME:AddMessage(GUPPET_TEXT_HELP_1);
		 DEFAULT_CHAT_FRAME:AddMessage(GUPPET_TEXT_HELP_2);
		 
	end
end

-- // At Loading // --
function GupPet_OnLoad(self)

	SLASH_GP1 = "/GupPets";
	SLASH_GP2 = "/GP"

	SlashCmdList["GP"] = GupPet_SlashCommand;
	
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("COMPANION_LEARNED");
		
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA"); -- For update fly
	self:RegisterEvent("LEARNED_SPELL_IN_TAB");  -- For update fly
	
	self:RegisterEvent("ZONE_CHANGED");  
	self:RegisterEvent("ZONE_CHANGED_INDOORS");  
	self:RegisterEvent("CHAT_MSG_ADDON")
	
	self:RegisterEvent("UNIT_ENTERING_VEHICLE");
	self:RegisterEvent("UNIT_EXITED_VEHICLE");
end

 


-- // Event Handlers. // --
function GupPet_OnEvent(self, event) --self, event, ...

	if event == "COMPANION_LEARNED" then

		GupPet_Debug( "New Pet/Mount" );
		
		GupPet_CreateLocalMountList() ; 
		GupPet_CreateLocalCritterList() ;
		GupPetOptionInterface() ;
		 
		
		 
		
	elseif event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		
		DEFAULT_CHAT_FRAME:AddMessage( GUPPET_TEXT_WELCOME );
		
		GupPet_CreateLocalMountList() ; 
		GupPet_CreateLocalCritterList() ;
		GupPetOptionInterface() ;
		
		GUPPET_CANFLY = GupPet_CanFly() ;
		
		if ( IsInGuild() ) then
		
			if GupPet_GetVersion() < GUPPET_OPTIONS.NewVersionFound then
				SendAddonMessage("GupPetVersion", GUPPET_OPTIONS.NewVersionFound , "GUILD") ;
			else
				SendAddonMessage("GupPetVersion", GupPet_GetVersion() , "GUILD") ;
			end
		end 
		
		GupPet_AutoCallCritterBoot() ;
	
	elseif event == "ZONE_CHANGED_NEW_AREA" or event == "LEARNED_SPELL_IN_TAB" then
		
		GUPPET_CANFLY = GupPet_CanFly() ;	
	
	elseif event == "VARIABLES_LOADED" then

		GupPet_Debug( "Vars Loaded" );
		
		-- For updating 
		if not GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint then	GUPPET_INTERFACEOPTIONS.MainUIFrameRelativePoint = "CENTER" ; 		end
		if not GUPPET_INTERFACEOPTIONS.MainUIFrameDrag then				GUPPET_INTERFACEOPTIONS.MainUIFrameDrag = false ;					end
		if not GUPPET_OPTIONS.AutoCallCritter then						GUPPET_OPTIONS.AutoCallCritter = false ;							end
		if not GUPPET_OPTIONS.AutoCallCritterCityOnly then				GUPPET_OPTIONS.AutoCallCritterCityOnly = false ;					end
		
		if not GUPPET_MOUNTS.AquaticMount then
		
			GUPPET_MOUNTS.AquaticMount = {} ;
			GUPPET_MOUNTS.AquaticMount.Total = 0 ;
		
		end
		

		
	elseif event == "CHAT_MSG_ADDON" and arg1 == "GupPetVersion" then
		n_arg2 = tonumber( arg2 ) ;
	
		
	
		if n_arg2 > GupPet_GetVersion() and n_arg2 > GUPPET_OPTIONS.NewVersionFound   then
			 
			GupPet_Text( GUPPET_TEXT_NEWVERSIONFOUND .. arg2) ;
			GUPPET_OPTIONS.NewVersionFound = n_arg2 ;
			GupPetOptionInterface() ; -- UPDATE INTERFACE --
		end
		
		
 
	elseif ( event == "UNIT_ENTERING_VEHICLE" and arg1 == "player" ) then
		 GUPPET_INTERFACE.MainUI.Frame:Hide(); 
 
	elseif ( event == "UNIT_EXITED_VEHICLE" and arg1 == "player" and GUPPET_INTERFACEOPTIONS.MainUIFrameShow == true )   then
		 
		 GUPPET_INTERFACE.MainUI.Frame:Show(); 

		 
	end	

	
	
	if event == "ZONE_CHANGED" or event == "ZONE_CHANGED_INDOORS" or event == "ZONE_CHANGED_NEW_AREA" then	
		
		GupPet_CanFlyDalaran() ;
	end
	
			
	
end

-- // Geeft de totale versie terug // --
function GupPet_GetVersion()
	local DataVersion, DataVersionRest = math.modf(GUPPET_DATAVERSION) ;
	local ScriptVersion, ScriptVersionRest = math.modf(GUPPET_SCRIPTVERSION) ;
	local LocalizationVersion, LocalizationVersionRest = math.modf(GUPPET_LOCALIZATIONVERSION) ;
	local InterfaceVersion , InterfaceVersionRest = math.modf(GUPPET_INTERFACEVERSION) ;

	local MainVersion = math.max( DataVersion , ScriptVersion , LocalizationVersion , InterfaceVersion );
				
				
	-- Wird wy it needs toString and toNumber but else it wont do math things correctly 			
	return tonumber(tostring ( MainVersion + DataVersionRest + ScriptVersionRest + LocalizationVersionRest + InterfaceVersionRest)) ;
	

end


-- // Verander de status in het database. // --
function GupPetPanel_SetStatus( Type , ID , Checked , What , TotalWhat )

	if Type == "GUPPET_CRITTERS" then
		
		if ID == 9999 then
			
			if Checked then
				for i =1 , GUPPET_CRITTERS["Total"] do
		
					GUPPET_CRITTERS[ i ]["Enabled"] = 1 ;
		
				end
				
				GUPPET_CRITTERS["TotalEnabled"] = GUPPET_CRITTERS["Total"] ;
			else
				for i =1 , GUPPET_CRITTERS["Total"] do
		
					GUPPET_CRITTERS[ i ]["Enabled"] = 0 ;
		
				end
				
				GUPPET_CRITTERS["TotalEnabled"] = 0 ;

			end
	
		else
	
	
	
			if Checked then
						
				GUPPET_CRITTERS[ ID ]["Enabled"] = 1 ;
				GUPPET_CRITTERS["TotalEnabled"] = GUPPET_CRITTERS["TotalEnabled"] + 1 ;
				
				GupPet_Debug( "Status --Type:"..Type.."  ID:"..ID.."  Checked: 1"   );
			else
				
				GUPPET_CRITTERS[ ID ]["Enabled"] = 0 ;
				GUPPET_CRITTERS["TotalEnabled"] = GUPPET_CRITTERS["TotalEnabled"] - 1 ;
				
				GupPet_Debug( "Status --Type:"..Type.."  ID:"..ID.."  Checked: 0"   );	
			end
		end
	
	else
		if ID == 9999 then
			
			if Checked then
				for i =1 , GUPPET_MOUNTS[ Type ]["Total"] do
		
					GUPPET_MOUNTS[ Type ][ i ][ What ] = 1 ;
		
				end
				
				GUPPET_MOUNTS[ Type ][TotalWhat] = GUPPET_MOUNTS[ Type ]["Total"] ;
			else
				for i =1 , GUPPET_MOUNTS[ Type ]["Total"] do
		
					GUPPET_MOUNTS[ Type ][ i ][ What ] = 0 ;
		
				end
				
				GUPPET_MOUNTS[ Type ][TotalWhat] = 0 ;

			end
	
		else
	
			if Checked then
						
				GUPPET_MOUNTS[ Type ][ ID ][ What ] = 1 ;
				GUPPET_MOUNTS[ Type ][TotalWhat] = GUPPET_MOUNTS[ Type ][TotalWhat] + 1 ;
				
				GupPet_Debug( "Status --Type:"..Type.."  ID:"..ID.."  Checked: 1"   );
			else
				
				GUPPET_MOUNTS[ Type ][ ID ][ What ] = 0 ;
				GUPPET_MOUNTS[ Type ][TotalWhat] = GUPPET_MOUNTS[ Type ][TotalWhat] - 1 ;
				
				GupPet_Debug( "Status --Type:"..Type.."  ID:"..ID.."  Checked: 0"   );	
			end
		end
	end
		
end

-- // Display Debug information if Debug is enabled. // --
function GupPet_Debug( text )

	if GUPPET_OPTIONS.Debug then
		DEFAULT_CHAT_FRAME:AddMessage( text );
	end

end

function GupPet_Text( text )
	
	DEFAULT_CHAT_FRAME:AddMessage( "GupPet: ".. text ) ;

end


-- //  Do Automount. // --
function GupPet_AutoMount()
			
	if (IsMounted()) then
	
		Dismount() ;
		
	else
		
		if( not(IsFlyableArea()) or ( GetZoneText() == GUPPET_ZONE_DALARAN and GUPPET_CANFLYDALARAN == false ) or (GetZoneText() == GUPPET_ZONE_WINTERGRASP) or IsSwimming()) then
		else
					
			if GUPPET_MOUNTS[ "FastFlyMount" ]["TotalEnabled"] > 0 and GUPPET_CANFLY then
		
				GupPet_Mounten( "FastFlyMount" , "Enabled" , "TotalEnabled" ) ;
				return ;
			
			elseif GUPPET_MOUNTS[ "SlowFlyMount" ]["TotalEnabled"] > 0 and GUPPET_CANFLY then 
			
				GupPet_Mounten( "SlowFlyMount" , "Enabled" , "TotalEnabled" ) ;
				return ;
			end	
			
		end
		
		_, instanceType = IsInInstance() ;
		
		
		if ( GUPPET_MOUNTS[ "AquaticMount" ]["TotalEnabled"] > 0 and IsSwimming() ) then
		
			GupPet_Mounten( "AquaticMount" , "Enabled" , "TotalEnabled" ) ;
						
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledCity"] > 0 and IsResting() ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledCity" , "TotalEnabledCity" ) ;
		
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledBattleGround"] > 0 and instanceType == "pvp" ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledBattleGround" , "TotalEnabledBattleGround" ) ;
			
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledArena"] > 0 and instanceType == "arena" ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledArena" , "TotalEnabledArena" ) ;
		
		elseif ( GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabledInstance"] > 0 and ( instanceType == "party" or instanceType == "raid" ) ) then
		
			GupPet_Mounten( "FastGroundMount" , "EnabledInstance" , "TotalEnabledInstance" ) ;	
				
		elseif GUPPET_MOUNTS[ "FastGroundMount" ]["TotalEnabled"] > 0 then
		
			GupPet_Mounten( "FastGroundMount" , "Enabled" , "TotalEnabled" ) ;
			
		elseif GUPPET_MOUNTS[ "SlowGroundMount" ]["TotalEnabled"] > 0 then 
			
			GupPet_Mounten( "SlowGroundMount" , "Enabled" , "TotalEnabled" ) ;
		else
				GupPet_Text( GUPPET_TEXT_CANTCALLMOUNT ) ;
		end
		
		
		
	end

end

-- //  Do RandomMount by typeMount. // --
function GupPet_Mounten( typeMount , what , totalWhat  ) 

	local randomMount =  math.random( GUPPET_MOUNTS[ typeMount ][totalWhat]  ) ;
	local nrTemp  = 0 ;

	for nr = 1 , GUPPET_MOUNTS[ typeMount ]["Total"] do

		if ( GUPPET_MOUNTS[ typeMount ][ nr ][what] == 1 )then
	
			nrTemp = nrTemp +1 ;
		
			if nrTemp == randomMount then
		
				CallCompanion("MOUNT", GUPPET_MOUNTS[ typeMount ][ nr ]["Slot"] ) ;
								
				return ; 
			end
		end
	end
end

-- //  Can Fly in Dalaran. Cuz bliz have a crappy IsFlyableArea api // --
function GupPet_CanFlyDalaran()
	-- TODO .. Bliz realy should fix the IsFlyableArea api 
	
	GUPPETTEMP_NEWREALZONETEXT = GetRealZoneText() ;
	GUPPETTEMP_NEWREALSUBZONETEXT = GetSubZoneText();


	if ( GUPPETTEMP_OLDREALZONETEXT == GUPPET_ZONE_CRYSTALSONGFOREST and GUPPETTEMP_NEWREALZONETEXT == GUPPET_ZONE_DALARAN and GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_THEUNDERBELLY ) 
			or (  GUPPETTEMP_OLDREALSUBZONETEXT == GUPPET_SUBZONE_CANTRIPSCROWS and GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_THEUNDERBELLY ) 
				or ( GUPPETTEMP_NEWREALZONETEXT == GUPPET_ZONE_DALARAN and  GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_KRASUSLANDING ) 
						or ( GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_THEUNDERBELLY and GUPPET_CANFLYDALARAN )	
								or ( GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_THEVIOLETCITADEL and GUPPET_CANFLYDALARAN )
										or ( GUPPETTEMP_OLDREALSUBZONETEXT == GUPPET_SUBZONE_THEPURPLEPARLOR  and GUPPETTEMP_NEWREALSUBZONETEXT == GUPPET_SUBZONE_THEVIOLETCITADEL and IsOutdoors() )
	then

			GUPPET_CANFLYDALARAN = true ;
			GupPet_Debug("ENABLE FLY   Location = " .. GetRealZoneText() .. " - " .. GetSubZoneText()) ;
	else
			
			GUPPET_CANFLYDALARAN = false ;
			GupPet_Debug("DISABLE FLY   Location = " .. GetRealZoneText() .. " - " .. GetSubZoneText()) ;
	end
	
	GUPPETTEMP_OLDREALZONETEXT = GetRealZoneText() ;
	GUPPETTEMP_OLDREALSUBZONETEXT = GetSubZoneText();

end

-- //  Detect if you can fly in Northerend. // --
function GupPet_CanFly()
	GupPet_Debug( "GupPet_CanFly Start" );		

	local zoneNames = { GetMapZones(4) } ;
	local zoneName = GetZoneText();
	local whereAmI = false ;				-- If false not in norherend --
		
		
	for i = 1 , 11 do
		if zoneName ==  zoneNames[i] then
		
			whereAmI = true ;
		end
	end

	if whereAmI == false then
	
		GupPet_Debug( "GupPet_CanFly Return I'm NOT Northrend " );
	
		return true ;
	end

	local spellname = GetSpellInfo( 54197) ;
	local slot = 1 ;

	while GetSpellName(slot, "spell") do
		local name = GetSpellName(slot, "spell")
		if name == spellname then
			GupPet_Debug( "GupPet_CanFly Return SpellFound" );
			return true ;
		end
		slot = slot + 1 ;
	end
	
	GupPet_Debug( "GupPet_CanFly Return Spell NOT Found" );
	return false ;

end 

-- //  Call a critter. // --
function GupPet_CallCritter() 
	
	local less = 0 ;
	local NumSnowBals =  GetItemCount("Snowball");
	
	if  NumSnowBals == 0 then
		
		less =	GupPet_CountAnd( GUPPET_CRITTERS , "Enabled" , "UseSnowball") ;
		
	end
	
	if ( GUPPET_CRITTERS["TotalEnabled"] - less > 0 ) then
	
		local randomCritter =  math.random( GUPPET_CRITTERS["TotalEnabled"]-less  ) ;
		local nrTemp  = 0 ;
		
		for nr = 1 , GUPPET_CRITTERS["Total"] do

			if ( GUPPET_CRITTERS[ nr ]["Enabled"] == 1 and NumSnowBals > 0 ) or ( GUPPET_CRITTERS[ nr ]["Enabled"] == 1 and GUPPET_CRITTERS[ nr ]["UseSnowball"] == 0   ) then
		
				nrTemp = nrTemp +1 ;
			
				if nrTemp == randomCritter then
			
					local _, _, _, icon, issummoned = GetCompanionInfo("CRITTER", nr );
					GupPet_Debug( icon ) ;

					CallCompanion("CRITTER", GUPPET_CRITTERS[ nr ]["Slot"] ) ;
					return ; 
				end
			end
		end
	elseif less > 0 then
	
		GupPet_Text( GUPPET_TEXT_CANTCALLCRITTERNOSNOWBALL ) ;
	
	else
		GupPet_Text( GUPPET_TEXT_CANTCALLCRITTER ) ;
	
	end	
end

-- //  Create the local critter list. // --
function GupPet_CreateLocalCritterList()
	GupPet_Debug( "GupPet_CreateLocalCritterList Start" );

	GUPPET_TEMPCRITTERS = { Total=0} ;
	useSnowball = 0 ;
	GUPPET_TEMPCRITTERS_NR = 0 ;
	
	for slot = 1, GetNumCompanions("CRITTER") do
		local _, creatureName, creatureSpellID = GetCompanionInfo("CRITTER", slot) ;
		
		useSnowball = 0 ;
		
		for DBID, DBMountData in pairs(GUPPET_CRITTER_MAINDATA) do
			
			if ((DBID == creatureSpellID) and DBMountData[1]) then
		
				useSnowball = 1 ;
			
			end
		end
		
		EnabledT = 1 ;
		for i = 1 , GUPPET_CRITTERS["Total"] do
			if GUPPET_CRITTERS[i]["Id"] == creatureSpellID then
				EnabledT = GUPPET_CRITTERS[i]["Enabled"] ;
			end
		end
				
		GUPPET_TEMPCRITTERS_NR = GUPPET_TEMPCRITTERS_NR + 1 ;
		GUPPET_TEMPCRITTERS[ GUPPET_TEMPCRITTERS_NR ] = { Name = creatureName , Id = creatureSpellID, Slot = slot , UseSnowball = useSnowball  ,Enabled = EnabledT } ;
	end 

	GUPPET_TEMPCRITTERS["Total"] =  GetNumCompanions("CRITTER") ;
	GUPPET_TEMPCRITTERS["TotalEnabled"] = GupPet_CheckEnabled(GUPPET_TEMPCRITTERS) ;
	GUPPET_TEMPCRITTERS["TotalUseSnowball"] = GupPet_Count(GUPPET_TEMPCRITTERS , "UseSnowball") ;
	GUPPET_CRITTERS = GUPPET_TEMPCRITTERS ;
	
	GupPet_Debug( "GupPet_CreateLocalCritterList End" );
end

-- //  Create the local Mount list. // --
function GupPet_CreateLocalMountList()
	GupPet_Debug( "GupPet_CreateLocalMountList Start" );		
	
	
	GP_SLOWGROUNDMOUNT = {} ;
	GP_SLOWFLYMOUNT = {};
	GP_FASTGROUNDMOUNT = {};
	GP_FASTFLYMOUNT = {};
	GP_AQUATICMOUNT = {}; --AquaticMount
	GP_UNKNOWNMOUNT = {};
	
	GP_SLOWGROUNDMOUNT_NR = 0 ;
	GP_SLOWFLYMOUNT_NR = 0 ;
	GP_FASTGROUNDMOUNT_NR = 0 ;
	GP_FASTFLYMOUNT_NR = 0 ;
	GP_AQUATICMOUNT_NR = 0;
	GP_UNKNOWNMOUNT_NR = 0 ;
	
	for slot = 1, GetNumCompanions("MOUNT") do
		local _, creatureName, creatureSpellID , creatureIcon = GetCompanionInfo("MOUNT", slot) ;
		
		for DBMountID, DBMountData in pairs(GUPPET_MOUNTS_MAINDATA) do
		
			if (DBMountID == creatureSpellID) then
		
				if ( DBMountData[1] ) then
					
					EnabledT = 1 ;
					
					for i = 1 , GUPPET_MOUNTS["SlowGroundMount"]["Total"] do
						if GUPPET_MOUNTS["SlowGroundMount"][i]["Id"] == creatureSpellID then
							EnabledT = GUPPET_MOUNTS["SlowGroundMount"][i]["Enabled"] ;
						end
					end
					
					GP_SLOWGROUNDMOUNT_NR = GP_SLOWGROUNDMOUNT_NR + 1 ;
					GP_SLOWGROUNDMOUNT[ GP_SLOWGROUNDMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Icon = creatureIcon ,Slot = slot , Enabled = EnabledT } ;
				end
				
				if ( DBMountData[2] ) then
				
					EnabledT = 1 ;
					EnabledTArena = 0 ;
					EnabledTBattleGround = 0 ;
					EnabledTCity = 0 ; 
					EnabledTInstance = 0 ;
					
					for i = 1 , GUPPET_MOUNTS["FastGroundMount"]["Total"] do
						if GUPPET_MOUNTS["FastGroundMount"][i]["Id"] == creatureSpellID then
							EnabledT = GUPPET_MOUNTS["FastGroundMount"][i]["Enabled"] ;
							EnabledTArena = GUPPET_MOUNTS["FastGroundMount"][i]["EnabledArena"] ;
							EnabledTBattleGround = GUPPET_MOUNTS["FastGroundMount"][i]["EnabledBattleGround"] ;
							EnabledTCity = GUPPET_MOUNTS["FastGroundMount"][i]["EnabledCity"] ;
							EnabledTInstance = GUPPET_MOUNTS["FastGroundMount"][i]["EnabledInstance"] ;
						end
					end
				
					GP_FASTGROUNDMOUNT_NR = GP_FASTGROUNDMOUNT_NR + 1 ;
					GP_FASTGROUNDMOUNT[ GP_FASTGROUNDMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Icon = creatureIcon ,Slot = slot , Enabled = EnabledT , EnabledArena = EnabledTArena , 	EnabledBattleGround = EnabledTBattleGround , EnabledCity = EnabledTCity , EnabledInstance = EnabledTInstance } ;
				end
				
				if ( DBMountData[11] ) then
				
					EnabledT = 1 ;
					for i = 1 , GUPPET_MOUNTS["SlowFlyMount"]["Total"] do
						if GUPPET_MOUNTS["SlowFlyMount"][i]["Id"] == creatureSpellID then
							EnabledT = GUPPET_MOUNTS["SlowFlyMount"][i]["Enabled"] ;
						end
					end
				
					GP_SLOWFLYMOUNT_NR = GP_SLOWFLYMOUNT_NR + 1 ;
					GP_SLOWFLYMOUNT[ GP_SLOWFLYMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Icon = creatureIcon ,Slot = slot , Enabled = EnabledT } ;
				end
				
				if ( DBMountData[12] ) then
				
					EnabledT = 1 ;
					for i = 1 , GUPPET_MOUNTS["FastFlyMount"]["Total"] do
						if GUPPET_MOUNTS["FastFlyMount"][i]["Id"] == creatureSpellID then
							EnabledT = GUPPET_MOUNTS["FastFlyMount"][i]["Enabled"] ;
						end
					end
				
					GP_FASTFLYMOUNT_NR = GP_FASTFLYMOUNT_NR + 1 ;	
					GP_FASTFLYMOUNT[ GP_FASTFLYMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Icon = creatureIcon ,Slot = slot , Enabled = EnabledT } ;
				end		

				if ( DBMountData[21] ) then
				
					EnabledT = 1 ;
					for i = 1 , GUPPET_MOUNTS["AquaticMount"]["Total"] do
						if GUPPET_MOUNTS["AquaticMount"][i]["Id"] == creatureSpellID then
							EnabledT = GUPPET_MOUNTS["AquaticMount"][i]["Enabled"] ;
						end
					end
				
					GP_AQUATICMOUNT_NR = GP_AQUATICMOUNT_NR + 1 ;	
					GP_AQUATICMOUNT[ GP_AQUATICMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Icon = creatureIcon ,Slot = slot , Enabled = EnabledT } ;
				end		
				
				if ( DBMountData[1] or DBMountData[2] or DBMountData[11] or DBMountData[12] or DBMountData[21] ) then
				else
					GP_UNKNOWNMOUNT_NR = GP_UNKNOWNMOUNT_NR + 1 ;	
					GP_UNKNOWNMOUNT[ GP_UNKNOWNMOUNT_NR ] = { Name = creatureName , Id = creatureSpellID, Slot = slot , Enabled = 1 } ;
					
					GupPet_Text( GUPPET_TEXT_UNKNOWNMOUNTFOUND .. creatureName .. "," .. creatureSpellID ) ;
				end

			end
		end
	end 

	GP_SLOWGROUNDMOUNT["Total"] = GP_SLOWGROUNDMOUNT_NR;
	GP_SLOWGROUNDMOUNT["TotalEnabled"] = GupPet_CheckEnabled(GP_SLOWGROUNDMOUNT) ;

	
	GP_FASTGROUNDMOUNT["Total"] =  GP_FASTGROUNDMOUNT_NR;
	GP_FASTGROUNDMOUNT["TotalEnabled"] = GupPet_CheckEnabled(GP_FASTGROUNDMOUNT) ;
	GP_FASTGROUNDMOUNT["TotalEnabledArena"] = GupPet_Count(GP_FASTGROUNDMOUNT , "EnabledArena") ;
	GP_FASTGROUNDMOUNT["TotalEnabledBattleGround"] = GupPet_Count(GP_FASTGROUNDMOUNT , "EnabledBattleGround") ;
	GP_FASTGROUNDMOUNT["TotalEnabledCity"] = GupPet_Count(GP_FASTGROUNDMOUNT , "EnabledCity") ;
	GP_FASTGROUNDMOUNT["TotalEnabledInstance"] = GupPet_Count(GP_FASTGROUNDMOUNT , "EnabledInstance") ;
	
	
	GP_SLOWFLYMOUNT["Total"] =  GP_SLOWFLYMOUNT_NR;
	GP_SLOWFLYMOUNT["TotalEnabled"] = GupPet_CheckEnabled(GP_SLOWFLYMOUNT) ;
	
	GP_FASTFLYMOUNT["Total"] = GP_FASTFLYMOUNT_NR;
	GP_FASTFLYMOUNT["TotalEnabled"] = GupPet_CheckEnabled(GP_FASTFLYMOUNT) ;
	
	GP_AQUATICMOUNT["Total"] = GP_AQUATICMOUNT_NR;
	GP_AQUATICMOUNT["TotalEnabled"] = GupPet_CheckEnabled(GP_AQUATICMOUNT) ;
	
	GP_UNKNOWNMOUNT["Total"] = GP_UNKNOWNMOUNT_NR;
	
	GUPPET_MOUNTS = { SlowGroundMount = GP_SLOWGROUNDMOUNT , SlowFlyMount =  GP_SLOWFLYMOUNT , FastGroundMount = GP_FASTGROUNDMOUNT , FastFlyMount = GP_FASTFLYMOUNT , AquaticMount = GP_AQUATICMOUNT , UnknownMount = GP_UNKNOWNMOUNT } ;

	GupPet_Debug( "GupPet_CreateLocalMountList End" );				
end

-- //  Counter for Enabled mounts. // --
function GupPet_CheckEnabled( Mount )

	AantalEnabled = 0 ;

	for i = 1 , Mount["Total"] do
	
		if Mount[i]["Enabled"] == 1 then
	
			AantalEnabled = AantalEnabled + 1 ;
		end
	end

	return AantalEnabled
end

-- //  Counter for data if what var is true. // --
function GupPet_Count( data , what )

	local Aantal = 0 ;

	for i = 1 , data["Total"] do
	
		if data[i][ what ] == 1 then
	
			Aantal = Aantal + 1 ;
		end
	end

	return Aantal
end

-- //  Counter for data if 2 vars are true. // --
function GupPet_CountAnd( data , what, andWhat )

	local Aantal = 0 ;

	for i = 1 , data["Total"] do
	
		if data[i][ what ] == 1 and data[i][ andWhat ] == 1 then
	
			Aantal = Aantal + 1 ;
		end
	end

	return Aantal
end





-- // Auto Call Critter Boot // --
function GupPet_AutoCallCritterBoot()

	AutoCallCritter.Frame = CreateFrame("Frame", "AutoCallCritterFrameq"); 
	AutoCallCritter.TotalElapsed = 0;
	AutoCallCritter.Delay = 2 ;
	AutoCallCritter.Frame:Hide() ;

	AutoCallCritter.Frame:SetScript("OnEvent", function(self, event) GupPet_AutoCallCritterEvent(event); end ) ;
	AutoCallCritter.Frame:SetScript("OnUpdate", function(self, elap) GupPet_AutoCallCritterUpdate(self, elap); end ) ;
	AutoCallCritter.Frame:SetScript("OnShow", function() AutoCallCritter.TotalElapsed = 0; end) ;
	
	GupPet_AutoCallCritterSetEnable( GUPPET_OPTIONS.AutoCallCritter , GUPPET_OPTIONS.AutoCallCritterCityOnly ) ;
	
	
	
end

-- // Auto Call Critter Update // --
function GupPet_AutoCallCritterUpdate(self, elap)

	AutoCallCritter.TotalElapsed = AutoCallCritter.TotalElapsed + elap ;
	
	if AutoCallCritter.TotalElapsed > AutoCallCritter.Delay then 
		
		AutoCallCritter.TotalElapsed = 0 ;
		
		local spellCasting, _, _, _, _, endTime = UnitCastingInfo("player") ;
		local spellChannel, _, _, _, _, endTime = UnitChannelInfo("player") ;
		
		local UnitSpeed = GetUnitSpeed("player") ;
		GupPet_Debug( "GupPet_AutoCallCritterEvent  UnitSpeed "..UnitSpeed ) ;
		
		
		if IsMounted() or IsFlying()  then
		
			GupPet_Debug( "GupPet_AutoCallCritterUpdate  Return") ;
			AutoCallCritter.Frame:Hide() ;
			return 
			
		
		elseif IsStealthed() or spellCasting or spellChannel or InCombatLockdown() or not(HasFullControl())  or UnitBuff("player", "Spirit of Redemption") or UnitSpeed > 0 then
				
			GupPet_Debug( "GupPet_AutoCallCritterUpdate  Return") ;
			return 
		end
			
			
		for i=1,GetNumCompanions("CRITTER") do 

			_, _, _, _, IsSummoned = GetCompanionInfo("CRITTER", i);
		
			if IsSummoned then 
		
				GupPet_Debug( "GupPet_AutoCallCritterEvent  Return Already ") ;
				AutoCallCritter.Frame:Hide() ;
				return ;
			end 
		end	
			
		GupPet_CallCritter() ;
		AutoCallCritter.Frame:Hide() ;		
		
	end

end


function GupPet_AutoCallCritterSetEnable( enable , city )

	GUPPET_OPTIONS.AutoCallCritter = enable ;
	GUPPET_OPTIONS.AutoCallCritterCityOnly = city ;

	if enable then
	
		if city then
			GUPPET_INTERFACE.MainUI.buttonCritter:Show() ;
		else
			GUPPET_INTERFACE.MainUI.buttonCritter:Hide() ;
		end
	
		AutoCallCritter.Frame:RegisterEvent("COMPANION_UPDATE") ;		--For dismounting
		AutoCallCritter.Frame:RegisterEvent("PLAYER_UNGHOST") ; 		--Walking to corpse
		AutoCallCritter.Frame:RegisterEvent("PLAYER_ALIVE") ;			--Res
		
		AutoCallCritter.Frame:RegisterEvent("ZONE_CHANGED") ;			--Portal or summon not far away 
		AutoCallCritter.Frame:RegisterEvent("ZONE_CHANGED_NEW_AREA") ;	--Portal 
		AutoCallCritter.Frame:RegisterEvent("PLAYER_CONTROL_GAINED") ; 	--After taxi
		AutoCallCritter.Frame:RegisterEvent("UNIT_EXITED_VEHICLE") ; 	--After using a vehicle 
		
		GupPet_Debug( "GupPet_AutoCallCritterSetEnable RegisterEvent") ;
		
		
		AutoCallCritter.Frame:Show() ;
		
		GUPPET_INTERFACE.SubSchermCritters.AutoCallCritterCityOnly:Enable() ;
				
	else

		AutoCallCritter.Frame:UnregisterEvent("COMPANION_UPDATE") ;
		AutoCallCritter.Frame:UnregisterEvent("PLAYER_UNGHOST") ;	
		AutoCallCritter.Frame:UnregisterEvent("PLAYER_ALIVE") ;		
		AutoCallCritter.Frame:UnregisterEvent("ZONE_CHANGED_NEW_AREA") ;
		AutoCallCritter.Frame:UnregisterEvent("ZONE_CHANGED") ;
		AutoCallCritter.Frame:UnregisterEvent("PLAYER_CONTROL_GAINED") ;
		AutoCallCritter.Frame:UnregisterEvent("UNIT_EXITED_VEHICLE") ;
		
		
		AutoCallCritter.Frame:Hide() ;
		GUPPET_INTERFACE.MainUI.buttonCritter:Show() ;
				
		GUPPET_INTERFACE.SubSchermCritters.AutoCallCritterCityOnly:Disable() ;

	end
		
end

-- // Auto Call Critter Event // --
function GupPet_AutoCallCritterEvent(event )

	if GUPPET_OPTIONS.AutoCallCritterCityOnly and not(IsResting()) then
			
		GupPet_Debug( "GupPet_AutoCallCritterEvent  Return AutoCallCritterCityOnly") ;
		return ;
	
	end
  
  
	GupPet_Debug( "GupPet_AutoCallCritterEvent  " .. event   );		
		
	if InCombatLockdown() then 
		
		GupPet_Debug( "GupPet_AutoCallCritterEvent  Return InCombatLockdown") ;
		AutoCallCritter.Frame:RegisterEvent("PLAYER_REGEN_ENABLED") ;
		return  ;
	else
		AutoCallCritter.Frame:UnregisterEvent("PLAYER_REGEN_ENABLED") ;
	end
				
	if not( HasFullControl() ) then 
		GupPet_Debug( "GupPet_AutoCallCritterEvent  Return HasNOControl ") ;
		return ;
	end
				
	GupPet_Debug( "GupPet_AutoCallCritterEvent  Show") ;
	AutoCallCritter.Frame:Show() ;
end



	